/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\

   Filename: tocpatch.cpp
   Autor:    mate
   Date:     18.02.2009
   Modifed:	 24.04.2009
   
   Version:  v1.1.0.0.0.0.0.0_0 :P
   
   Note:     Ez a kis kd javtja a tartalomjegyzket,
             ami a magyarosts miatt nem j.
             
   Fordts: gcc tocpatch.cpp -Wall -o tocpatch.exe
   
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum {
NONE = 0,
IZE,
BACKSLASH,
CHAR_R,
CHAR_E,
CHAR_L,
CHAR_A,
CHAR_X
};

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
void usage( void ) {
     
     printf("\nUsage:\n\ntocpatch <filename>.toc\n\nFigyelem! Az eredeti file fellirasra kerl!");
     getchar();
     return;     
}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\

  A prog hzimbl jl jn ez a kd :)
  
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
char * xml_buffer_file( char * filename )
{

     FILE * xmlfile;
     char * buffer = NULL;
     long  filesize;
     long ii;

     xmlfile = fopen(filename, "rb");
     if (xmlfile == NULL) {
        printf("xml_buffer_file(): Can't open file! %s\n", filename);
        return NULL;
     }

     if (fseek(xmlfile, 0L, SEEK_END) != 0) {
        printf("xml_buffer_file(): Can't seek file! %s\n", filename);
        fclose(xmlfile);
        return NULL;
     }

     if ((filesize = ftell(xmlfile)) == -1L) {
        printf("xml_buffer_file(): Can't ftell file! %s\n", filename);
        fclose(xmlfile);
        return NULL;
     }

     rewind(xmlfile);

     buffer = (char*)malloc((filesize+3)*sizeof(char));
     if (buffer == NULL) {
        printf("xml_buffer_file(): Out of memory!\n");
        fclose(xmlfile);
        return NULL;
     }

     for (ii=0;ii<filesize+2;ii++)
        buffer[ii] = 0x00;


     if (fread(buffer, filesize, 1, xmlfile) == 0) {
        printf("xml_buffer_file(): Can't read file! %s\n", filename);
        fclose(xmlfile);
        free(buffer);
        return NULL;
     }

     buffer[filesize+1] = '\0';

     fclose(xmlfile);

     return buffer;
}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
void patch_tocfile( FILE * file, char * memo ) {
     
     int ii = 0;
     int state = NONE;
     char c = '\0';
     
     while ( memo[ii] != 0x00 ) {
           
		   if (ii == 0 && strlen(memo) >= 3) { // utf-8 BOM tugrsa
				if (((unsigned char)memo[ii]) == 0xef && ((unsigned char)memo[ii+1]) == 0xbb && ((unsigned char)memo[ii+2]) == 0xbf) {
					ii = 3;
					if (memo[ii] == 0x00)
						break;
				}
		   }
		   
           c = memo[ii];
           
		   switch ( state ) {
                  case ( NONE ): {
                       if ( c == '{')
                          state = IZE;
                       else
                         fprintf( file, "%c", c );
                  } break;
                  case ( IZE ): {
                       if ( c == '\\')
                          state = BACKSLASH;
                       else {
                            fprintf( file, "{%c", c );
                            state = NONE;
                       }
                  } break;
                  case ( BACKSLASH ): {
                       if ( c == 'r')
                          state = CHAR_R;
                       else {
                            fprintf( file, "{\\%c", c );
                            state = NONE;
                       }
                  } break;
                  case ( CHAR_R ): {
                       if ( c == 'e')
                          state = CHAR_E;
                       else {
                            fprintf( file, "{\\r%c", c );
                            state = NONE;
                       }
                  } break;
                  case ( CHAR_E ): {
                       if ( c == 'l')
                          state = CHAR_L;
                       else {
                            fprintf( file, "{\\re%c", c );
                            state = NONE;
                       }
                  } break;
                  case ( CHAR_L ): {
                       if ( c == 'a')
                          state = CHAR_A;
                       else {
                            fprintf( file, "{\\rel%c", c );
                            state = NONE;
                       }
                  } break;
                  case ( CHAR_A ): {
                       if ( c == 'x')
                          state = CHAR_X;
                       else {
                            fprintf( file, "{\\rela%c", c );
                            state = NONE;
                       }
                  } break;
                  case ( CHAR_X ): {
                       if ( c == ' ') {
                          fprintf( file, "{" );
                       } else {
                            fprintf( file, "{%c", c );
                       }
                       state = NONE;
                  } break;
           }
           
           ii++;
           
     }
     
     return;
}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int main( int argc, char ** argv ) {

    char * memo = NULL;
    FILE * file = NULL;
    
    if (argc < 2) {
       usage();
       return -1;
    }
    
    if (argv[1] == NULL) {
       usage();
       return -1;
    }
    
    printf("## Patching file: %s\n", argv[1]);
    
    memo = xml_buffer_file( argv[1] );
    if (!memo) {
        getchar();
        return -1;
    }
    
    file = fopen(argv[1], "wb");
    if (!file) {
       printf("Can't open file: %s\n", argv[1]);
       free(memo);
       getchar();
       return -2;
    }
    
    patch_tocfile( file, memo );
    
    printf("ok\n\n");
    
    fclose(file);
    free(memo);
    return 0;
}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
